struct hdr_mftp {
    enum { PDU_DATA_TRANSFER, PDU_STATUS_REQUEST, PDU_NAK }; // allowed types of PDU's

    int type;          // field for PDU-type
    // instead of "class Spec", should use "union Spec", but doesn't work
    // since CW_PATTERN_t is a class.
    class Spec {       // specific part of the PDU (different for different types)
    public:
        class Data {            // PDU_DATA_TRANSFER:
        public:
            unsigned long pass_nb;
            unsigned long group_nb;
            CW_PATTERN_t cw_pat;
        } data;
        class StatReq {         // PDU_STATUS_REQUEST:
        public:
            unsigned long pass_nb;     // pass number the status request belongs to
            unsigned long block_lo;    // lowest block number requested for NAK-feedback
            unsigned long block_hi;    // highest block number requested
            double   RspBackoffWindow; // length of backoff-interval that receivers
            // are supposed to use when generating a random time (from a uniform
            // distribution) before (potentially) sending NACKs.
        } statReq;
        class Nak {             // PDU_NAK:
        public:
            unsigned long pass_nb;
            unsigned long block_nb;
            unsigned long nak_count;
            // the actual nak-bitmap will be found in a variable length field that
            // is dynamically allocated.
        } nak;
    } spec;

    // Header access methods
    static int offset_; // required by PacketHeaderManager
    inline static int& offset() { return offset_; }
    inline static hdr_mftp* access(const Packet* p) {
        return (hdr_mftp*) p->access(offset_);
    }
};
